makedefs   [plain text]


#!/bin/sh

#++
# NAME
#	makedefs 1
# SUMMARY
#	makefile configuration utility
# SYNOPSIS
#	\fBmake makefiles \fIname=value...\fR
# DESCRIPTION
#	The \fBmakedefs\fR command identifies the compilation
#	environment, and emits macro definitions on the standard output
#	stream that can be prepended to template Makefiles.
#
#	Default settings can be overruled by specifying them as
#	environment variables. Use quotes if variables contain
#	whitespace or shell meta characters.
# .IP \fBAUXLIBS=\fIobject_library...\fR
#	Specifies one or more non-default object libraries.
# .IP \fBCC=\fIcompiler_command\fR
#	Specifies a non-default compiler. On many systems, the default
#	is \fBgcc\fR.
# .IP \fBCCARGS=\fIcompiler_arguments\fR
#	Specifies non-default compiler arguments, for example, a non-default
#	\fIinclude\fR directory.
#	The following directives are special:
# .RS
# .IP \fB-DNO_DEVPOLL\fR
#	Do not build with Solaris /dev/poll support.
#	By default, /dev/poll support is compiled in on platforms that
#	are known to support it.
# .IP \fB-DNO_EPOLL\fR
#	Do not build with Linux EPOLL support.
#	By default, EPOLL support is compiled in on platforms that
#	are known to support it.
# .IP \fB-DNO_KQUEUE\fR
#	Do not build with FreeBSD/NetBSD/OpenBSD KQUEUE support.
#	By default, KQUEUE support is compiled in on platforms that
#	are known to support it.
# .IP \fB-DNO_IPV6\fR
#	Do not build with IPv6 support.
#	By default, IPv6 support is compiled in on platforms that
#	are known to have IPv6 support.
# .IP \fB-DNO_PCRE\fR
#	Do not build with PCRE support.
#	By default, PCRE support is compiled in when the \fBpcre-config\fR
#	utility is installed.
# .RE
# .IP \fBDEBUG=\fIdebug_level\fR
#	Specifies a non-default debugging level. The default is \fB-g\fR.
#	Specify \fBDEBUG=\fR to turn off debugging.
# .IP \fBOPT=\fIoptimization_level\fR
#	Specifies a non-default optimization level. The default is \fB-O\fR.
#	Specify \fBOPT=\fR to turn off optimization.
# .IP \fBWARN=\fIwarning_flags\fR
#	Specifies non-default gcc compiler warning options for use when
#	"make" is invoked in a source subdirectory only.
# LICENSE
# .ad
# .fi
#	The Secure Mailer license must be distributed with this software.
# AUTHOR(S)
#	Wietse Venema
#	IBM T.J. Watson Research
#	P.O. Box 704
#	Yorktown Heights, NY 10598, USA
#--

# Emit system-dependent Makefile macro definitions to standard output.

# Defaults for most sane systems

RANLIB=ranlib
SYSLIBS=
AR=ar
ARFL=rv

# Ugly function to make our error message more visible among the
# garbage that is output by some versions of make(1).

# By now all shells must have functions.

error() {
   # Alas, tput(1) is not portable so we can't use visual effects.
   echo "ATTENTION:" 1>&2;
   echo "ATTENTION:" $* 1>&2;
   echo "ATTENTION:" 1>&2;
   exit 1
}

SYSTEM=`(uname -s) 2>/dev/null`
RELEASE=`(uname -r) 2>/dev/null`
VERSION=`(uname -v) 2>/dev/null`

case "$VERSION" in
 dcosx*) SYSTEM=$VERSION;;
esac

case "$SYSTEM.$RELEASE" in
   SCO_SV.3.2)	SYSTYPE=SCO5
		# Use the native compiler by default
		: ${CC="/usr/bin/cc -b elf"}
		CCARGS="$CCARGS -DPIPES_CANT_FIONREAD $CCARGS"
		SYSLIBS="-lsocket -ldbm"
		RANLIB=echo
		;;
  UnixWare.5*)	SYSTYPE=UW7
		# Use the native compiler by default
		: ${CC=/usr/bin/cc}
		RANLIB=echo
		SYSLIBS="-lresolv -lsocket -lnsl"
		;;
  UNIX_SV.4.2*)	case "`uname -v`" in
	      2.1*) SYSTYPE=UW21
		    # Use the native compiler by default
		    : ${CC=/usr/bin/cc}
		    RANLIB=echo
		    SYSLIBS="-lresolv -lsocket -lnsl -lc -L/usr/ucblib -lucb"
		    ;;
	      *) error "Seems to be UnixWare`uname -v`. Untested.";;
		esac
		;;
  FreeBSD.2*)	SYSTYPE=FREEBSD2
		;;
  FreeBSD.3*)	SYSTYPE=FREEBSD3
		;;
  FreeBSD.4*)	SYSTYPE=FREEBSD4
		;;
  FreeBSD.5*)	SYSTYPE=FREEBSD5
		;;
  FreeBSD.6*)	SYSTYPE=FREEBSD6
		;;
  OpenBSD.2*)	SYSTYPE=OPENBSD2
		;;
  OpenBSD.3*)	SYSTYPE=OPENBSD3
		;;
  OpenBSD.4*)	SYSTYPE=OPENBSD4
		;;
  ekkoBSD.1*)	SYSTYPE=EKKOBSD1
		;;
   NetBSD.1*)	SYSTYPE=NETBSD1
		;;
   NetBSD.2*)	SYSTYPE=NETBSD2
		;;
   NetBSD.3*)	SYSTYPE=NETBSD3
		;;
   NetBSD.4*)	SYSTYPE=NETBSD4
		;;
   BSD/OS.2*)	SYSTYPE=BSDI2
		;;
   BSD/OS.3*)	SYSTYPE=BSDI3
		;;
   BSD/OS.4*)	SYSTYPE=BSDI4
		;;
 OSF1.V[3-5].*)	SYSTYPE=OSF1
		# Use the native compiler by default
		: ${CC=cc}
		: ${DEBUG="-g3"}
		case $RELEASE in
		V[0-4].*) CCARGS="$CCARGS -DNO_IPV6";;
		esac
		;;
    SunOS.4*)	SYSTYPE=SUNOS4
		SYSLIBS=-lresolv
		;;
    SunOS.5*)	SYSTYPE=SUNOS5
		RANLIB=echo
		SYSLIBS="-lresolv -lsocket -lnsl"
		# Solaris 5 added usleep() and POSIX regular expressions
		case $RELEASE in
		    5.[0-4]) CCARGS="$CCARGS -DMISSING_USLEEP -DNO_POSIX_REGEXP";;
		esac
		# Solaris 8 added IPv6 and /dev/poll
		case $RELEASE in
		    5.[0-7]|5.[0-7].*) CCARGS="$CCARGS -DNO_IPV6 -DNO_DEVPOLL";;
		esac
		# Solaris 9 added closefrom(), futimesat() and /dev/*random
		case $RELEASE in
		    5.[0-8]|5.[0-8].*) CCARGS="$CCARGS -DNO_CLOSEFROM -DNO_DEV_URANDOM -DNO_FUTIMESAT";;
		esac
		# Work around broken str*casecmp(). Do it all here instead
		# of having half the solution in the sys_defs.h file.
		CCARGS="$CCARGS -Dstrcasecmp=fix_strcasecmp \
			-Dstrncasecmp=fix_strncasecmp"
		STRCASE="strcasecmp.o"
		# Avoid common types of braindamage
		case "$LD_LIBRARY_PATH" in
		?*) error "Don't set LD_LIBRARY_PATH";;
		esac
		case "${CC}" in
		*" "*) ;;
		*ucb*) error "Don't use /usr/ucb/cc or ucblib";;
		  cc*) case `which ${CC}` in
		*ucb*) error "Don't use /usr/ucb/cc or ucblib";;
		  esac;;
		esac
		;;
   ULTRIX.4*)	SYSTYPE=ULTRIX4
		if [ -f /usr/local/lib/libdb.a ]; then
		    SYSLIBS="$SYSLIBS -ldb"
		    CCARGS="$CCARGS -DHAS_DB"
		    if [ -d /usr/local/include/db ]; then
			CCARGS="$CCARGS -I/usr/local/include/db"
		    fi
		fi
		for l in syslog resolv; do
		    if [ -f /usr/local/lib/lib$l.a ]; then
			SYSLIBS="$SYSLIBS -l$l"
		    fi
		done
		;;
       AIX.*)	case "`uname -v`" in
		5)	SYSTYPE=AIX5
			case "$CC" in
			cc|*/cc|xlc|*/xlc) CCARGS="$CCARGS -w -blibpath:/usr/lib:/lib:/usr/local/lib";;
			esac
			CCARGS="$CCARGS -D_ALL_SOURCE -DHAS_POSIX_REGEXP"
			;;
		4)	SYSTYPE=AIX4
			# How embarrassing...
			case "$CC" in
			cc|*/cc|xlc|*/xlc) OPT=; CCARGS="$CCARGS -w -blibpath:/usr/lib:/lib:/usr/local/lib";;
			esac
			CCARGS="$CCARGS -D_ALL_SOURCE -DHAS_POSIX_REGEXP"
			;;
		3)	SYSTYPE=AIX3
			# How embarrassing...
			case "$CC" in
			cc|*/cc|xlc|*/xlc) OPT=; CCARGS="$CCARGS -w";;
			esac
			CCARGS="$CCARGS -D_ALL_SOURCE"
			;;
		*)	error "Unknown AIX version: `uname -v`.";;
		esac;;
		# Tested with RedHat 3.03 on 20020729.
    Linux.1*)	SYSTYPE=LINUX1
		SYSLIBS="-ldb"
		;;
    Linux.2*)	SYSTYPE=LINUX2
		# Postfix no longer needs DB 1.85 compatibility
		if [ -f /usr/include/db.h ]
		then
		    : we are all set
		elif [ -f /usr/include/db/db.h ]
		then
		    CCARGS="$CCARGS -I/usr/include/db"
		else
		    # No, we're not going to try db1 db2 db3 etc.
		    # On a properly installed system, Postfix builds
		    # by including <db.h> and by linking with -ldb
		    echo "No <db.h> include file found." 1>&2
		    echo "Install the appropriate db*-devel package first." 1>&2
		    echo "See the RELEASE_NOTES file for more information." 1>&2
		    exit 1
		fi
		# GDBM locks the DBM .pag file after open. This breaks postmap.
		# if [ -f /usr/include/gdbm-ndbm.h ]
		# then
		#     CCARGS="$CCARGS -DHAS_DBM -DPATH_NDBM_H='<gdbm-ndbm.h>'"
		#     GDBM_LIBS=gdbm
		# elif [ -f /usr/include/gdbm/ndbm.h ]
		# then
		#     CCARGS="$CCARGS -DHAS_DBM -DPATH_NDBM_H='<gdbm/ndbm.h>'"
		#     GDBM_LIBS=gdbm
		# fi
		SYSLIBS="-ldb"
		for name in nsl resolv $GDBM_LIBS
		do
		    for lib in /usr/lib64 /lib64 /usr/lib /lib
		    do
			test -e $lib/lib$name.a -o -e $lib/lib$name.so && {
			    SYSLIBS="$SYSLIBS -l$name"
			    break
			}
		    done
		done
		# Kernel 2.4 added IPv6
		case "$RELEASE" in
		2.[0-3].*) CCARGS="$CCARGS -DNO_IPV6";;
		esac
		# Kernel 2.6 added EPOLL
		case "$RELEASE" in
		2.[0-5].*) CCARGS="$CCARGS -DNO_EPOLL";;
		esac
		;;
     GNU.0*|GNU/kFreeBSD.[56]*)
     		SYSTYPE=GNU0
		# Postfix no longer needs DB 1.85 compatibility
		if [ -f /usr/include/db.h ]
		then
		    : we are all set
		elif [ -f /usr/include/db/db.h ]
		then
		    CCARGS="$CCARGS -I/usr/include/db"
		else
		    # No, we're not going to try db1 db2 db3 etc.
		    # On a properly installed system, Postfix builds
		    # by including <db.h> and by linking with -ldb
		    echo "No <db.h> include file found." 1>&2
		    echo "Install the appropriate db*-devel package first." 1>&2
		    echo "See the RELEASE_NOTES file for more information." 1>&2
		    exit 1
		fi
		SYSLIBS="-ldb"
		for name in nsl resolv
		do
		    for lib in /usr/lib64 /lib64 /usr/lib /lib
		    do
			test -e $lib/lib$name.a -o -e $lib/lib$name.so && {
			    SYSLIBS="$SYSLIBS -l$name"
			    break
			}
		    done
		done
		case "`uname -s`" in
		GNU)
			# currently no IPv6 support on Hurd
			CCARGS="$CCARGS -DNO_IPV6"
			;;
		esac
		;;
     IRIX*.5.*)	SYSTYPE=IRIX5
		# Use the native compiler by default
		: ${CC=cc} ${DEBUG="-g3"}
		RANLIB=echo
		;;
     IRIX*.6.*)	SYSTYPE=IRIX6
		# Use the native compiler by default, and allow nested comments.
		: ${CC="cc -woff 1009,1116,1412"}
		RANLIB=echo
		;;
HP-UX.A.09.*)	SYSTYPE=HPUX9
		SYSLIBS=-ldbm
		CCARGS="$CCARGS -DMISSING_USLEEP"
		if [ -f /usr/lib/libdb.a ]; then
		    CCARGS="$CCARGS -DHAS_DB"
		    SYSLIBS="$SYSLIBS -ldb"
		fi
		;;
HP-UX.B.10.*)	SYSTYPE=HPUX10
		CCARGS="$CCARGS `nm /usr/lib/libc.a 2>/dev/null |
		    (grep usleep >/dev/null || echo '-DMISSING_USLEEP')`"
		if [ -f /usr/lib/libdb.a ]; then
		    CCARGS="$CCARGS -DHAS_DB"
		    SYSLIBS=-ldb
		fi
		;;
HP-UX.B.11.*)	SYSTYPE=HPUX11
		SYSLIBS=-lnsl
		if [ -f /usr/lib/libdb.a ]; then
		    CCARGS="$CCARGS -DHAS_DB"
		    SYSLIBS="$SYSLIBS -ldb"
		fi
		;;
ReliantUNIX-?.5.43) SYSTYPE=ReliantUnix543
		RANLIB=echo
		SYSLIBS="-lresolv -lsocket -lnsl"
		;;
Rhapsody.5*|Darwin.*)
		SYSTYPE=MACOSX
		# Use the native compiler by default
		: ${CC=cc}
		case $RELEASE in
		 1.[0-3]) AWK=gawk
			  CCARGS="$CCARGS -DNO_IPV6"
			  ;;
		 [2-6].*) AWK=awk
			  CCARGS="$CCARGS -DNO_IPV6"
			  SYSLIBS=-flat_namespace
			  ;;
		       *) AWK=awk
			  SYSLIBS=-flat_namespace
			  CCARGS="$CCARGS -DBIND_8_COMPAT -DNO_NETINFO"
			  ;;
		esac
		;;
"Mac OS".10*)	SYSTYPE=MACOSX
		# Use the native compiler by default
		: ${CC=cc}
		AWK=gawk
		;;
    dcosx.1*)	SYSTYPE=DCOSX1
		RANLIB=echo
		SYSLIBS="-lresolv -lsocket -lnsl -lc -lrpcsvc -L/usr/ucblib -lucb"
		;;

	 ".")	if [ -d /NextApps ]; then
		    SYSTYPE=`hostinfo | sed -n \
			's/^.*NeXT Mach 3.*$/NEXTSTEP3/;/NEXTSTEP3/{p;q;}'`
		    if [ "$SYSTYPE" = "" ]; then
			SYSTYPE=`hostinfo | sed -n \
			    's/^.*NeXT Mach 4.*$/OPENSTEP4/;/OPENSTEP4/{p;q;}'`
		    fi
		    : ${CC=cc}
		    RANLIB="sleep 5; ranlib"
		else
		    error "Unable to determine your system type."
		fi
		;;
	   *)	error "Unknown system type: $SYSTEM $RELEASE";;
esac

#
# OpenSSL has no configuration query utility, but we don't try to
# guess. We assume includes in /usr/include/openssl and libraries in
# /usr/lib, or in their /usr/local equivalents. If the OpenSSL files
# are in a non-standard place, their locations need to be specified.
#
#case "$CCARGS" in
# *-DUSE_TLS*)	;;
#  *-DNO_TLS*)	;;
#           *)	CCARGS="$CCARGS -DUSE_TLS"
#		AUXLIBS="$AUXLIBS -lssl -lcrypto"
#		;;
#esac

#
# PCRE 3.x has a pcre-config utility so we don't have to guess.
#
case "$CCARGS" in
*-DHAS_PCRE*)	;;
 *-DNO_PCRE*)	;;
           *)	pcre_cflags=`(pcre-config --cflags) 2>/dev/null` &&
		    pcre_libs=`(pcre-config --libs) 2>/dev/null` && {
			CCARGS="$CCARGS -DHAS_PCRE $pcre_cflags"
			AUXLIBS="$AUXLIBS $pcre_libs"
		}
		;;
esac

# Defaults that can be overruled (make makefiles CC=cc OPT=-O6 DEBUG=)
# Disable optimizations by default when compiling for Purify. Disable
# optimizations by default with gcc 2.8, until the compiler is known to
# be OK. Those who dare can still overrule this (make makefiles OPT=-O).

case "$CC" in
 *purify*) : ${OPT=};;
*/gcc|gcc) case `$CC -v` in
	   "gcc version 2.8"*) : ${OPT=};;
	   esac;;
      *CC) error "Don't use CC. That's the C++ compiler";;
        *) : ${OPT='-O'};;
esac
#
# "gcc -W" 3.4.2 no longer reports functions that fail to return a
# result.  Use "gcc -Wall -Wno-comment" instead. We'll figure out
# later if the other -Wmumble options are really redundant. Having
# een burned once by a compiler that lies about what warnings it
# produces, not taking that chance again.

: ${CC='gcc $(WARN)'} ${OPT='-O'} ${DEBUG='-g'} ${AWK=awk} \
${WARN='-Wall -Wno-comment -Wformat -Wimplicit -Wmissing-prototypes \
	-Wparentheses -Wstrict-prototypes -Wswitch -Wuninitialized \
	-Wunused'}

export SYSTYPE AR ARFL RANLIB SYSLIBS CC OPT DEBUG AWK OPTS

# Snapshot only.
#CCARGS="$CCARGS -DSNAPSHOT"

# Non-production: needs thorough testing, or major changes are still
# needed before the code stabilizes.
#CCARGS="$CCARGS -DNONPROD"

sed 's/  / /g' <<EOF
SYSTYPE	= $SYSTYPE
AR	= $AR
ARFL	= $ARFL
RANLIB	= $RANLIB
SYSLIBS	= $AUXLIBS $SYSLIBS
CC	= $CC $CCARGS
OPT	= $OPT
DEBUG	= $DEBUG
AWK	= $AWK
STRCASE = $STRCASE
EXPORT	= AUXLIBS='$AUXLIBS' CCARGS='$CCARGS' OPT='$OPT' DEBUG='$DEBUG'
WARN	= $WARN
EOF